/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef color_cycle_h
#define color_cycle_h

typedef struct{
    enum{
        CCD_OFF,
        CCD_LEFT,
        CCD_RIGHT
    }direction;
    double duration;
    int first;
    int last;
}color_cycle_t;

int color_cycle_total_frames(color_cycle_t *, int count);
double color_cycle_total_duration(color_cycle_t *, int count);
void color_cycle_apply_step(color_cycle_t *, void *palette, int colorsize);
void color_cycle_apply_time(color_cycle_t *, double time, void *palette, int colorsize);

#endif /* color_cycle_h */
