/*
 * Copyright (C) 2020  Magnus Bergman <magnus@snisurset.net>
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, see <http:/www.gnu.org/licenses/>
 */
#include <stddef.h>                     /* NULL */

#include "pc88.h"


void
pc88_default_palette(pc88_cairo_color_t *palette)
{
    int i;
    for(i=0;i<8;++i)
#if 1
        palette[i] = (i&1 ? 0x1f<<0 : 0) |
                     (i&2 ? 0x1f<<11 : 0) |
                     (i&4 ? 0x3f<<5 : 0);
#else
        palette[i] = (i&1 ? 0xff<<0 : 0) |
                     (i&2 ? 0xff<<16 : 0) |
                     (i&4 ? 0xff<<8 : 0);
#endif
}


#if 0
cairo_surface_t *
pc88_decode_image(uint8_t **bitplane, pc88_cairo_color_t *palette)
{
    cairo_surface_t *surface = cairo_image_surface_create(CAIRO_FORMAT_RGB24, 640, 200);
    pc88_cairo_color_t *dst = (pc88_cairo_color_t*)cairo_image_surface_get_data(surface);
    int rowskip = cairo_image_surface_get_stride(surface)/sizeof(pc88_cairo_color_t)-640;
    int y;
    for(y=0;y<200;++y){
        int x;
        for(x=0;x<80;++x){
            int plane1 = bitplane[0][x+y*80];
            int plane2 = bitplane[1][x+y*80];
            int plane3 = bitplane[2][x+y*80];
            int i;
            for(i=7;i>=0;--i){
                int pixel = (plane1 & (1<<i) ? 1 : 0) |
                            (plane2 & (1<<i) ? 2 : 0) |
                            (plane3 & (1<<i) ? 4 : 0);
                *dst++ = palette[pixel];
            }
        }
        dst += rowskip;
    }
    cairo_surface_mark_dirty(surface);
    return surface;
}
#endif
